<?php

/* By Qassim Hassan, wp-time.com */

function Qassim_Get_Recent_Tweets($consumer_key, $consumer_secret, $user_name, $count, $cache, $session_tweets, $session_cache){
    $base64 = base64_encode("$consumer_key:$consumer_secret");
    $header = array(
                    "Authorization: Basic $base64",
                    "Content-Type: application/x-www-form-urlencoded;charset=UTF-8",
                ); // Header array

    $data =  http_build_query( array("grant_type" => "client_credentials") ); // If no data, enter 0, like this: $data = 0;
    $url = 'https://api.twitter.com/oauth2/token';
    $method = 1; // Method type: 1 = POST, 0 = GET.
    $get_access_token = Qassim_HTTP($method, $url, $header, $data);
    $access_token = $get_access_token['access_token']; // Your access token!

    $Header =  array("Authorization: Bearer $access_token"); // Header with our access token.
    $Data = 0;
    $Method = 0;
    $username = $user_name;
    $tweets_count = $count;
    $Url = "https://api.twitter.com/1.1/statuses/user_timeline.json?screen_name=$username&count=$tweets_count";
    $result = Qassim_HTTP($Method, $Url, $Header, $Data);

    if( isset($_SESSION["$session_cache"]) and time() > $_SESSION["$session_cache"] ){
        unset($_SESSION["$session_tweets"]);
        unset($_SESSION["$session_cache"]);
    }

    if( !isset($_SESSION["$session_tweets"]) ){
        $_SESSION["$session_tweets"] = $result;
        $get_tweets = $_SESSION["$session_tweets"];
        $_SESSION["$session_cache"] =  time() + $cache;
    }
    else{
        $get_tweets = $_SESSION["$session_tweets"];
    }

    return $get_tweets;
}

?>